//---------------------------------------------------------------------------
// (c)Alex A. Trubetskoy            alextr438@yandex.ru
//---------------------------------------------------------------------------
// ListViewFilesAXCtl.cpp : Implementation of the CListViewFilesAXCtrl ActiveX Control class.

#include "stdafx.h"
#include "ListViewFilesAX.h"
#include "ListViewFilesAXCtl.h"
#include "ListViewFilesAXPpg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CListViewFilesAXCtrl, COleControl)

const unsigned colCount = 4;       //count of columns

/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CListViewFilesAXCtrl, COleControl)
	//{{AFX_MSG_MAP(CListViewFilesAXCtrl)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CListViewFilesAXCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CListViewFilesAXCtrl)
	DISP_FUNCTION(CListViewFilesAXCtrl, "updateData", updateData, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CListViewFilesAXCtrl, "getDirectory", getDirectory, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CListViewFilesAXCtrl, "setDirectory", setDirectory, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CListViewFilesAXCtrl, "getDrive", getDrive, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CListViewFilesAXCtrl, "setDrive", setDrive, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CListViewFilesAXCtrl, "getFileName", getFileName, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CListViewFilesAXCtrl, "getFilePath", getFilePath, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CListViewFilesAXCtrl, "isDirSelected", isDirSelected, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CListViewFilesAXCtrl, "getSelectedCount", getSelectedCount, VT_I4, VTS_NONE)
	DISP_FUNCTION(CListViewFilesAXCtrl, "getNextSelectedItem", getNextSelectedItem, VT_I4, VTS_I4)
	DISP_FUNCTION(CListViewFilesAXCtrl, "getFirstSelectedItem", getFirstSelectedItem, VT_I4, VTS_NONE)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CListViewFilesAXCtrl, COleControl)
	//{{AFX_EVENT_MAP(CListViewFilesAXCtrl)
	EVENT_STOCK_CLICK()
	EVENT_STOCK_DBLCLICK()
	EVENT_STOCK_KEYDOWN()
	EVENT_STOCK_KEYPRESS()
	EVENT_STOCK_KEYUP()
	EVENT_STOCK_MOUSEDOWN()
	EVENT_STOCK_MOUSEMOVE()
	EVENT_STOCK_MOUSEUP()
	EVENT_STOCK_READYSTATECHANGE()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CListViewFilesAXCtrl, 1)
	PROPPAGEID(CListViewFilesAXPropPage::guid)
END_PROPPAGEIDS(CListViewFilesAXCtrl)

/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CListViewFilesAXCtrl, "LISTVIEWFILESAX.ListViewFilesAXCtrl.1",
	0xa7fad655, 0x9d3e, 0x438c, 0xab, 0xb5, 0x25, 0xd9, 0xc5, 0x16, 0x71, 0xbc)

/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CListViewFilesAXCtrl, _tlid, _wVerMajor, _wVerMinor)

/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DListViewFilesAX =
		{ 0xdaae8857, 0x3120, 0x4e2d, { 0x8e, 0xb1, 0x27, 0xef, 0x69, 0x8f, 0xbd, 0x41 } };
const IID BASED_CODE IID_DListViewFilesAXEvents =
		{ 0x3ba1a293, 0x2dce, 0x48ca, { 0x90, 0x5f, 0x17, 0x2, 0xd0, 0xe2, 0x89, 0xaf } };

/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwListViewFilesAXOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CListViewFilesAXCtrl, IDS_LISTVIEWFILESAX, _dwListViewFilesAXOleMisc)

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl::CListViewFilesAXCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CListViewFilesAXCtrl

BOOL CListViewFilesAXCtrl::CListViewFilesAXCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_LISTVIEWFILESAX,
			IDB_LISTVIEWFILESAX,
			afxRegInsertable | afxRegApartmentThreading,
			_dwListViewFilesAXOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl::CListViewFilesAXCtrl - Constructor

CListViewFilesAXCtrl::CListViewFilesAXCtrl()
{
	InitializeIIDs(&IID_DListViewFilesAX, &IID_DListViewFilesAXEvents);

	// TODO: Initialize your control's instance data here.
	dir = "c:\\";
    drive = 'c';
}

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl::~CListViewFilesAXCtrl - Destructor

CListViewFilesAXCtrl::~CListViewFilesAXCtrl()
{
	// TODO: Cleanup your control's instance data here.
	delete pImageList;
}

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl::OnDraw - Drawing function

void CListViewFilesAXCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
}

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl::DoPropExchange - Persistence support

void CListViewFilesAXCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl::OnResetState - Reset control to default state

void CListViewFilesAXCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl message handlers

int CListViewFilesAXCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	pListCtrl = new CListCtrl();
	pListCtrl->Create(WS_CHILD | WS_VISIBLE | WS_BORDER | LVS_REPORT |
		LVS_SORTASCENDING,
		CRect(0, 0, lpCreateStruct->cx, lpCreateStruct->cy), this, 1);

	pImageList = new CImageList();
	pImageList->Create(16, 16, ILC_COLOR32, 0, 4);

	LVCOLUMN columns[colCount];
    pListCtrl->SetImageList(pImageList, LVSIL_SMALL);

	columns[0].pszText = "Name";
	columns[0].cx = 150;
	columns[0].mask = LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM;
	columns[0].iSubItem = 0;

	columns[1].pszText = "Ext";
	columns[1].cx = 50;
	columns[1].iSubItem = 1;
	columns[1].mask = LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM;

	columns[2].pszText = "Size";
	columns[2].cx = 50;
	columns[2].mask = LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM;
	columns[2].iSubItem = 2;

	columns[3].pszText = "Date";
	columns[3].cx = 100;
	columns[3].mask = LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM;
	columns[3].iSubItem = 3;

	for(int i = 0; i < colCount; ++i)
		pListCtrl->InsertColumn(i, &columns[i]);
	
	searchFiles();
	
	return 0;
}

//---------------------------------------------------------------------------
void CListViewFilesAXCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	pListCtrl->MoveWindow(0, 0, cx, cy);
	
}

//---------------------------------------------------------------------------
//search all files in the current directory to show them on this control
void CListViewFilesAXCtrl::searchFiles()
{
    CString pathMask = dir + "*";
    WIN32_FIND_DATA findData;
	HANDLE hSearch;
	BOOL finished = FALSE;

	//clear ListCtrl and ImageList
    pListCtrl->DeleteAllItems();
	for(int i = 0; i < pImageList->GetImageCount(); ++i) {
		pImageList->Remove(i);
	}

	//search files
	hSearch = FindFirstFile(pathMask, &findData);
    if(hSearch == INVALID_HANDLE_VALUE)
        return;

    if(CString(findData.cFileName) != ".") { 
        addItem(findData);
    }

    while(FindNextFile(hSearch, &findData)) {
		if(CString(findData.cFileName) != ".")
			addItem(findData);
    }

    FindClose(hSearch);
}

//---------------------------------------------------------------------------
void CListViewFilesAXCtrl::addItem(WIN32_FIND_DATA& findData)
{
    LVITEM listItem;
    DWORD attr = 0;
    SHFILEINFO sfi;
    int inImage, point, inItem = 0;
    CString fileName, ext, temp, size;
	LPTSTR name = 0;
	SYSTEMTIME stTime;
	char time[11];

    SHGetFileInfo(dir + findData.cFileName, attr, &sfi, sizeof(SHFILEINFO),
                SHGFI_ICON | SHGFI_SMALLICON);
    inImage = pImageList->Add(sfi.hIcon);
	listItem.iImage = inImage;
	listItem.iItem = inItem;
	listItem.iSubItem = 0;
	listItem.mask = LVIF_TEXT | LVIF_IMAGE;
  
    if((findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) > 0) {
		name = new TCHAR[strlen(findData.cFileName) + 3];
		sprintf(name, "%c%s%c", '[', findData.cFileName, ']');
		listItem.pszText = name;
		ext = "";
		size = "<DIR>";
    }
    else {
		temp = findData.cFileName;
        point = temp.ReverseFind('.');

        if(point != -1) {
			fileName = temp.Mid(0, point);
			name = new TCHAR[point + 1];
			sprintf(name, "%s", (LPCSTR)fileName); 
			listItem.pszText = name;
			ext = temp.Mid(point + 1);
        }
        else {
            ext = "";
			listItem.pszText = findData.cFileName;
			name = 0;
        }	
		DWORD fileSize = findData.nFileSizeHigh * (MAXDWORD + 1) + 
							findData.nFileSizeLow;
		size.Format("%d", fileSize);
    }
	inItem = pListCtrl->InsertItem(&listItem);
	if(name)delete[] name;
	pListCtrl->SetItemText(inItem, 1, ext);
	pListCtrl->SetItemText(inItem, 2, size);
	FileTimeToSystemTime(&(findData.ftLastWriteTime), &stTime);
	wsprintf(time, "%02d-%02d-%d", stTime.wDay, stTime.wMonth, stTime.wYear);
	pListCtrl->SetItemText(inItem, 3, time);
}

//---------------------------------------------------------------------------
// set the current directory
void CListViewFilesAXCtrl::setDirectory(LPCTSTR newDir)
{
	dir = newDir;
    if(dir[dir.GetLength() - 1] != '\\')
        dir += "\\";
    drive = dir[0];
    searchFiles();
}

//---------------------------------------------------------------------------
// return the current directory
BSTR CListViewFilesAXCtrl::getDirectory()
{
    return dir.AllocSysString();
}

//---------------------------------------------------------------------------
// set the current drive
void CListViewFilesAXCtrl::setDrive(LPCTSTR newDrive)
{
    drive = newDrive[0];
    dir = CString(drive) + ":\\";
    searchFiles();
}

//---------------------------------------------------------------------------
// return the current drive
BSTR CListViewFilesAXCtrl::getDrive()
{
	CString strResult = drive;
	return strResult.AllocSysString();
}

//---------------------------------------------------------------------------
// return the path and the name of the selected item
BSTR CListViewFilesAXCtrl::getFilePath()
{
	CString path = dir + getFileName();
    return path.AllocSysString();
}

//---------------------------------------------------------------------------
// return only the name of the selected item
BSTR CListViewFilesAXCtrl::getFileName()
{
    CString path = "";
	POSITION pos = pListCtrl->GetFirstSelectedItemPosition();
	int slash;

    if(pos != NULL) {
		int nItem = pListCtrl->GetNextSelectedItem(pos);

        if(isDir(dir + pListCtrl->GetItemText(nItem, 0))) {
            path = getDirPath(dir + pListCtrl->GetItemText(nItem, 0));
			slash = path.ReverseFind('\\');
            if(slash != -1)
				path = path.Mid(slash + 1);
        }
        else {
			path = pListCtrl->GetItemText(nItem, 0);
			if((pListCtrl->GetItemText(nItem, 1)).GetLength())
				path += ("." + pListCtrl->GetItemText(nItem, 1));
        }
    }
    return path.AllocSysString();
}

//---------------------------------------------------------------------------
void CListViewFilesAXCtrl::updateData()
{
    searchFiles();
}

//---------------------------------------------------------------------------
// determine if the selected item is directory
BOOL CListViewFilesAXCtrl::isDirSelected()
{
	POSITION pos = pListCtrl->GetFirstSelectedItemPosition();
    if(pos != NULL) {
		int nItem = pListCtrl->GetNextSelectedItem(pos);
        return isDir(dir + pListCtrl->GetItemText(nItem, 0));
	}
    return FALSE;
}

//---------------------------------------------------------------------------
// determine if the item is directory
BOOL CListViewFilesAXCtrl::isDir(CString name)const
{
    WIN32_FIND_DATA findData;
	HANDLE hSearch;

	hSearch = FindFirstFile(name, &findData);
    if(hSearch != INVALID_HANDLE_VALUE) {
		if(findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            FindClose(hSearch);
            return TRUE;
        }
		FindClose(hSearch);
    }
    else {
        name = getDirPath(name);
		hSearch = FindFirstFile(name, &findData);
        if(hSearch != INVALID_HANDLE_VALUE) {
            if(findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
                FindClose(hSearch);
                return TRUE;
            }
			FindClose(hSearch);
        }
    }
    return FALSE;
}

//---------------------------------------------------------------------------
// return the directory's name (without [ and ])
CString CListViewFilesAXCtrl::getDirPath(CString str)const
{
    CString res, temp = "";
    if(str.GetLength()) {
        int i = str.GetLength() - 1;
        if(str[i] == '\\')
            --i;
		i = str.ReverseFind('\\');
        if((i != -1) && (str[str.GetLength() - 1] == ']')) {
            res = str.Mid(0, i + 1);
            temp = str.Mid(i + 1);
            temp.Delete(temp.GetLength() - 1, 1);
            temp.TrimLeft();
            temp.Delete(0, 1);
        }
    }
    return (res + temp);
}

//---------------------------------------------------------------------------
long CListViewFilesAXCtrl::getSelectedCount() 
{
	// TODO: Add your dispatch handler code here
	return (long)pListCtrl->GetSelectedCount();
}

//---------------------------------------------------------------------------
long CListViewFilesAXCtrl::getNextSelectedItem(long pos) 
{
	// TODO: Add your dispatch handler code here
	return (long)pListCtrl->GetNextItem((int)pos, LVNI_SELECTED);
}

//---------------------------------------------------------------------------
long CListViewFilesAXCtrl::getFirstSelectedItem() 
{
	// TODO: Add your dispatch handler code here
	return (long)pListCtrl->GetNextItem(-1, LVNI_SELECTED);
}

//---------------------------------------------------------------------------

