//---------------------------------------------------------------------------
// (c)Alex A. Trubetskoy            alextr438@yandex.ru
//---------------------------------------------------------------------------

#if !defined(AFX_LISTVIEWFILESAXCTL_H__8C500E6A_8D7C_4863_B96A_679AA3969D0E__INCLUDED_)
#define AFX_LISTVIEWFILESAXCTL_H__8C500E6A_8D7C_4863_B96A_679AA3969D0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// ListViewFilesAXCtl.h : Declaration of the CListViewFilesAXCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CListViewFilesAXCtrl : See ListViewFilesAXCtl.cpp for implementation.

class CListViewFilesAXCtrl : public COleControl
{
	DECLARE_DYNCREATE(CListViewFilesAXCtrl)

private:
	CListCtrl* pListCtrl;
	CString dir;                   //directory
	char drive;                    //drive
	CImageList* pImageList;

	void searchFiles();
	void addItem(WIN32_FIND_DATA& findData);
    BOOL isDir(CString)const;
    CString getDirPath(CString)const;

// Constructor
public:
	CListViewFilesAXCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CListViewFilesAXCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CListViewFilesAXCtrl();

	DECLARE_OLECREATE_EX(CListViewFilesAXCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CListViewFilesAXCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CListViewFilesAXCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CListViewFilesAXCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CListViewFilesAXCtrl)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CListViewFilesAXCtrl)
	afx_msg void updateData();
	afx_msg BSTR getDirectory();
	afx_msg void setDirectory(LPCTSTR dir);
	afx_msg BSTR getDrive();
	afx_msg void setDrive(LPCTSTR drive);
	afx_msg BSTR getFileName();
	afx_msg BSTR getFilePath();
	afx_msg BOOL isDirSelected();
	afx_msg long getSelectedCount();
	afx_msg long getNextSelectedItem(long pos);
	afx_msg long getFirstSelectedItem();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

// Event maps
	//{{AFX_EVENT(CListViewFilesAXCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CListViewFilesAXCtrl)
	dispidUpdateData = 1L,
	dispidGetDirectory = 2L,
	dispidSetDirectory = 3L,
	dispidGetDrive = 4L,
	dispidSetDrive = 5L,
	dispidGetFileName = 6L,
	dispidGetFilePath = 7L,
	dispidIsDirSelected = 8L,
	dispidGetSelectedCount = 9L,
	dispidGetNextSelectedItem = 10L,
	dispidGetFirstSelectedItemPosition = 11L,
	dispidGetSelectedItems = 12L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LISTVIEWFILESAXCTL_H__8C500E6A_8D7C_4863_B96A_679AA3969D0E__INCLUDED)
